using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using Railroads.ScenarioManager.Core;


namespace Railroads.ScenarioManager.Editors
{
	public partial class ConditionEditorBase : Railroads.ScenarioManager.Editors.EditorBase
	{
		private Condition m_oCondition = null;


		public ConditionEditorBase()
		{
			InitializeComponent();
		}


		protected override void OnSetNode(object node)
		{
			m_oCondition = (Condition)node;

			base.OnSetNode(node);

			if (m_oCondition != null)
			{
				txtDescription.Text = m_oCondition.Description;
				txtHeadline.Text = m_oCondition.NewsHeadline;
				txtText.Text = m_oCondition.NewsText;
				txtTitle.Text = m_oCondition.NewsTitle;
				ftxtNewsPicture.Text = m_oCondition.NewsBitmap;
			}
			else 
			{
				txtDescription.Text = "";
				txtHeadline.Text = "";
				txtText.Text = "";
				txtTitle.Text = "";
				ftxtNewsPicture.Text = "";
			}
		}


		private void txtDescription_TextChanged(object sender, EventArgs e)
		{
			if (m_bIgnoreEvents) return;
			m_oCondition.Description = txtDescription.Text;
		}

		private void txtTitle_TextChanged(object sender, EventArgs e)
		{
			if (m_bIgnoreEvents) return;
			m_oCondition.NewsTitle = txtTitle.Text;
		}

		private void txtHeadline_TextChanged(object sender, EventArgs e)
		{
			if (m_bIgnoreEvents) return;
			m_oCondition.NewsHeadline = txtHeadline.Text;
		}

		private void txtText_TextChanged(object sender, EventArgs e)
		{
			if (m_bIgnoreEvents) return;
			m_oCondition.NewsText = txtText.Text;
		}

		private void ftxtNewsPicture_TextChanged(object sender, EventArgs e)
		{
			if (m_bIgnoreEvents) return;
			m_oCondition.NewsBitmap = ftxtNewsPicture.Text;
		}
	}
}

