using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Globalization;
using System.Text;
using System.Windows.Forms;

using Railroads.ScenarioManager.Core;


namespace Railroads.ScenarioManager.Editors
{
	public partial class NetWorthConditionEditor : ConditionEditorBase
	{
		private NetWorthCondition m_oCondition = null;


		public NetWorthConditionEditor()
		{
			InitializeComponent();
		}

		protected override void OnSetNode(object node)
		{
			base.OnSetNode(node);

			cboNetWorth.Items.Clear();
			for (int i = 5; i < 100; i += 5)
			{
				cboNetWorth.Items.Add(((int)(i * 1000000)).ToString("N0"));
			}

			m_oCondition = (NetWorthCondition)node;
			cboNetWorth.Text = m_oCondition.NetWorth.ToString("N0");
			cboNetWorth.SelectedText = " ";
		}

		private void cboNetWorth_Leave(object sender, EventArgs e)
		{
			FormatValue();
		}

		private void cboNetWorth_KeyDown(object sender, KeyEventArgs e)
		{
			if (e.KeyCode == Keys.Enter)
			{
				FormatValue();
			}
		}

		private void FormatValue()
		{
			long n;
			if (long.TryParse(cboNetWorth.Text, NumberStyles.Number, CultureInfo.CurrentCulture, out n))
			{
				cboNetWorth.Text = n.ToString("N0");
				cboNetWorth.Select(cboNetWorth.Text.Length, 0);
			}
		}

		private void cboNetWorth_TextChanged(object sender, EventArgs e)
		{
			long n;
			if (long.TryParse(cboNetWorth.Text, NumberStyles.Number, CultureInfo.CurrentCulture, out n))
			{
				m_oCondition.NetWorth = n;
			}

			SetNodeText();
		}

		
	}
}
