using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

using Railroads.ScenarioManager.Core;


namespace Railroads.ScenarioManager.Editors
{
	public partial class OwnStockConditionEditor : ConditionEditorBase
	{
		private OwnStockCondition m_oCondition = null;


		public OwnStockConditionEditor()
		{
			InitializeComponent();
		}

		protected override void OnSetNode(object node)
		{
			base.OnSetNode(node);

			m_oCondition = (OwnStockCondition)node;

			cboPercentage.Items.Clear();
			for (int i = 10; i <= 100; i += 10)
			{
				cboPercentage.Items.Add(i);
			}

			cboPercentage.SelectedItem = m_oCondition.Percent;

			optPlayer.Checked = (m_oCondition.Owner == OwnerType.Player);
			optAnyOtherPlayer.Checked = (m_oCondition.Owner == OwnerType.AnyOtherThanPlayer);
			optAllOtherPlayers.Checked = (m_oCondition.Owner == OwnerType.AllOtherThanPlayer);
		}


		private void cboPercentage_SelectedIndexChanged(object sender, EventArgs e)
		{
			m_oCondition.Percent = (int)cboPercentage.SelectedItem;
			SetNodeText();
		}

		private void optPlayer_CheckedChanged(object sender, EventArgs e)
		{
			if (optPlayer.Checked) m_oCondition.Owner = OwnerType.Player;
			SetNodeText();
		}

		private void optAnyOtherPlayer_CheckedChanged(object sender, EventArgs e)
		{
			if (optAnyOtherPlayer.Checked) m_oCondition.Owner = OwnerType.AnyOtherThanPlayer;
			SetNodeText();
		}

		private void optAllOtherPlayers_CheckedChanged(object sender, EventArgs e)
		{
			if (optAllOtherPlayers.Checked) m_oCondition.Owner = OwnerType.AllOtherThanPlayer;
			SetNodeText();
		}
	}
}
