using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.IO;
using System.Text;
using System.Windows.Forms;

namespace Railroads.ScenarioManager
{
	public partial class FileTextBox : UserControl
	{
		const string STR_FILTER = "DDS files (*.dds)|*.dds|All files (*.*)|*.*";
		const string STR_TITLE = "Select Scenario Map Thumbnail";

		private string m_sFilter = STR_FILTER;
		private string m_sTitle = STR_TITLE;


		public FileTextBox()
		{
			InitializeComponent();
		}

		[Browsable(true), DesignerSerializationVisibility(DesignerSerializationVisibility.Visible)]
		public new event EventHandler TextChanged;

		private void OnTextChanged()
		{
			if (TextChanged != null) TextChanged(this, EventArgs.Empty);
		}


		[DefaultValue(STR_FILTER)]
		public string Filter { get { return m_sFilter; } set { m_sFilter = value; } }

		[DefaultValue(STR_TITLE)]
		public string Title { get { return m_sTitle; } set { m_sTitle = value; } }

		[DefaultValue("")]
		public override string Text { get { return txt.Text; } set { txt.Text = value; } }


		private void btn_Click(object sender, EventArgs e)
		{
			openFileDialog.Filter = m_sFilter;
			openFileDialog.FilterIndex = 0;

			openFileDialog.Title = m_sTitle;

			if (openFileDialog.ShowDialog(this) == DialogResult.OK)
			{
				txt.Text = Path.GetFileName(openFileDialog.FileName);
				OnTextChanged();
			}
		}

		private void txt_Resize(object sender, EventArgs e)
		{
			this.Height = txt.Height;
		}
	}
}
