using System;
using System.Collections.Generic;
using System.Text;
using Railroads.ScenarioManager.Core;
using System.Windows.Forms;

namespace Railroads.ScenarioManager
{
	public static class FormsHelper
	{
		public static void PopulateCityTypesCombo(ComboBox comboBox, Scenario scenario, bool allowAnyType)
		{
			comboBox.Items.Clear();
			if (allowAnyType) comboBox.Items.Add(ScenarioCityType.AnyCityType);

			SortedList<int, ScenarioCityType> oCities = new SortedList<int, ScenarioCityType>();
			foreach (ScenarioCityType oCityType in scenario.CityTypes.Values)
			{
				while (oCities.ContainsKey(oCityType.Size))
				{
					oCityType.Size++;
				}

				oCities.Add(oCityType.Size, oCityType);
			}

			foreach (ScenarioCityType oCityType in oCities.Values)
			{
				comboBox.Items.Add(oCityType);
			}
		}
	}
}
