using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Railroads.ScenarioManager.Core;

namespace Railroads.ScenarioManager
{
	public partial class ImportForm : Form
	{
		public ImportForm()
		{
			InitializeComponent();
		}

		private void cmdBrowse_Click(object sender, EventArgs e)
		{
			if (!string.IsNullOrEmpty(txtImportPath.Text))
			{
				openFileDialog.FileName = txtImportPath.Text;
			}

			if (openFileDialog.ShowDialog(this) == DialogResult.OK)
			{
				txtImportPath.Text = openFileDialog.FileName;
			}
		}

		private void cmdOk_Click(object sender, EventArgs e)
		{
			if (string.IsNullOrEmpty(txtImportPath.Text))
			{
				MessageBox.Show(this, "You must define the file to import.");
				return;
			}

			try
			{
				using (new CursorChanger(Cursors.WaitCursor))
				{
					Manager.Instance.Import(txtImportPath.Text, ScenarioExistsActionType.CreateNew);
				}

				this.DialogResult = DialogResult.OK;
				this.Close();
			}
			catch (Exception ex)
			{
				MessageBox.Show(this, "An exception occured while importing the scenario: " + ex.Message + Environment.NewLine + ex.StackTrace);
			}
		}
	}
}