using System;
using System.Diagnostics;
using System.Text;
using System.Windows.Forms;

namespace Railroads.ScenarioManager
{
	public partial class UnhandledExceptionForm : Form
	{
		private Exception _exception;

		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		public Exception Exception
		{
			[DebuggerStepThrough]
			get { return _exception; }
			[DebuggerStepThrough]
			set { _exception = value; }
		}

		public UnhandledExceptionForm()
		{
			InitializeComponent();
		}

		private void UnhandledExceptionForm_Load(object sender, EventArgs e)
		{
			txtSource.Text = _exception.Source;

			StringBuilder builder = new StringBuilder();
			builder.Append(_exception.Message);
			builder.Append(Environment.NewLine);
			builder.Append(_exception.StackTrace);
			builder.Append(Environment.NewLine);

			if (_exception.InnerException != null)
			{
				builder.Append(Environment.NewLine);
				builder.Append("-------------INNER EXCEPTION------------");
				builder.Append(_exception.InnerException.Message);
				builder.Append(Environment.NewLine);
				builder.Append(_exception.InnerException.StackTrace);
			}

			txtMessage.Text = builder.ToString();
		}

		private void cmdClose_Click(object sender, EventArgs e)
		{
			Close();
		}
	}
}