using System;
using System.Collections.Generic;
using System.Text;

namespace Railroads.ScenarioManager.Core
{
	public static class DepotGoodMapper
	{
		public static string[] GetDepot(Good good)
		{
			List<string> aResults = new List<string>();

			switch (good.Name.ToLower())
			{
				case "passengers":
				case "mail":
					aResults.AddRange(new string[] { "Depot", "Station", "Terminal" });
					break;

				case "food":
				case "wine":
				case "beer":
				case "manufactured goods":
				case "textiles":
				case "gold":
				case "arms":
				case "automobiles":
				case "paper":
				case "medicine":
				case "steel":
					//These are second level goods and have no annexes
					break;

				case "grapes":
					aResults.Add("Vineyard Annex");
					break;

				case "livestock":
					aResults.Add("Cattle Ranch Annex");
					break;

				case "swine":
					aResults.Add("Swine Farm Annex");
					break;

				case "milk":
					aResults.Add("Dairy Farm Annex");
					break;

				case "fish":
					aResults.Add("Fishery Annex");
					break;

				case "wool":
					aResults.Add("Sheep Farm Annex");
					break;

				case "nitrates":
					aResults.Add("Sheep Farm Annex");
					break;

				case "grain":
					aResults.Add("Grain Farm Annex");
					break;

				case "cornmeal":
					aResults.Add("Corn Fields Annex");
					break;

				case "wood":
					aResults.Add("Lumber Mill Annex");
					break;

				case "ore":
					aResults.Add("Gold Mine Annex");
					break;

				case "coal":
					aResults.Add("Coal Mine Annex");
					break;

				case "Oil":
					aResults.Add("Oil Well Annex");
					break;
			}

			return aResults.ToArray();
		}
	}
}
