using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using System.IO;

namespace Railroads.ScenarioManager.Core
{
	public class FileList
	{
		private string		m_sSource;
		private string		m_sDestination;

		
		
		public FileList(string source) : this(source, "")
		{
		}

		public FileList(string source, string destination)
		{
			m_sSource = source ;
			m_sDestination = Utility.AddTrailingSlash(destination) ;
		}



		public string Source { get { return m_sSource; } set { m_sSource = value; } }


		/// <summary>
		/// This is the optional destination for the files in the source list.  Note: this must be a folder.
		/// </summary>
		public string Destination { get { return m_sDestination; } set { m_sDestination = Utility.AddTrailingSlash(value); } }


		public string[] GetFiles()
		{
			if (string.IsNullOrEmpty(m_sSource)) return null;

			//Find last '\' character
			int iSlash = m_sSource.LastIndexOf('\\');
			if ((iSlash > 0) && (iSlash < (m_sSource.Length - 1)))
			{
				string sPath = m_sSource.Substring(0, iSlash);
				string sPattern = m_sSource.Substring(iSlash + 1);

				return Directory.GetFiles(sPath, sPattern);
			}
			else
			{
				return Directory.GetFiles(m_sSource);
			}
		}		
	}
}
