using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.Xml;

namespace Railroads.ScenarioManager.Core
{
	public class Depot : XmlSetting
	{
		private string		m_sName;
		private bool		m_bIsAnnex;


		public string Name { get { return m_sName; } set { m_sName = value; } }
		public bool IsAnnex { get { return m_bIsAnnex; } set { m_bIsAnnex = value; } }


		public override void ToXml(XmlNode node)
		{
			throw new NotImplementedException("The method or operation is not implemented.");
		}


		public override void FromXml(Scenario scenario, XmlNode node)
		{
			m_sName = Utility.GetChildElementValue<string>(node, "szName");
			int iTemp = Utility.GetChildElementValue<int>(node, "IsAnnex", 0, false);
			m_bIsAnnex = (iTemp == 1);
		}


		public override object Clone()
		{
			Depot oClone = new Depot();
			oClone.m_sName = m_sName;
			oClone.m_bIsAnnex = m_bIsAnnex;
			return oClone;
		}


		public override bool Validate(List<string> errors)
		{
			return true;
		}
	}
}
