using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Xml;

namespace Railroads.ScenarioManager.Core
{
	public class Good : XmlSetting
	{
		private string				m_sName;
		private string				m_sClass;
		private int					m_nMinPrice;
		private int					m_nMaxPrice;

		private List<TrainGoodCar>	m_oTrainCars = new List<TrainGoodCar>();


		public string Name { get { return m_sName; } set { m_sName = value; } }
		public string Class { get { return m_sClass; } set { m_sClass = value; } }
		public int MinPrice { get { return m_nMinPrice; } set { m_nMinPrice = value; } }
		public int MaxPrice { get { return m_nMaxPrice; } set { m_nMaxPrice = value; } }

		public string XmlName { get { return m_sName.StartsWith("<") ? m_sName.Substring(1, m_sName.Length - 2) : m_sName; } }


		public List<TrainGoodCar> TrainCars { get { return m_oTrainCars; } protected set { m_oTrainCars = value; } }


		public override void ToXml(XmlNode node)
		{
			throw new NotImplementedException();
		}


		public override void FromXml(Scenario scenario, XmlNode node)
		{
			m_sName = Utility.GetChildElementValue<string>(node, "szName");
			m_sClass = Utility.GetChildElementValue<string>(node, "szClass");
			m_nMinPrice = Utility.GetChildElementValue<int>(node, "MinPrice");
			m_nMaxPrice = Utility.GetChildElementValue<int>(node, "MaxPrice");
		}


		public override string ToString()
		{
			return m_sName;
		}


		public override object Clone()
		{
			Good oClone = new Good();
			oClone.m_sName = m_sName;
			oClone.m_sClass = m_sClass;
			oClone.m_nMinPrice = m_nMinPrice;
			oClone.m_nMaxPrice = m_nMaxPrice;
			return oClone;
		}


		public override bool Validate(List<string> errors)
		{
			throw new NotImplementedException();
		}
	}
}