using System;
using System.Collections.Generic;
using System.Text;

namespace Railroads.ScenarioManager.Core
{
	public static class Locations
	{
		public static string Default_MyGamesRailroadsFolder
		{
			get { return Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + @"\My Games\Sid Meier's Railroads!\"; }
		}


		public static string Default_GameFolder
		{
			get { return Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles) + @"\2K Games\Firaxis Games\Sid Meier's Railroads!"; }
		}


		public static string Default_WorkingDirectory
		{
			get { return Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + @"\My Games\Sid Meier's Railroads!\Workspace"; }
		}


		public static string MyCustomAssetsFolder
		{
			get { return ManagerApplication.AppSettings.MyRailroadsDirectory + @"CustomAssets\"; }
		}


		public static string MyScenariosFolder
		{
			get { return MyCustomAssetsFolder + @"XML\_SCENARIOS_\"; }
		}


		public static string MyUserMapsFolder
		{
			get { return ManagerApplication.AppSettings.MyRailroadsDirectory + @"UserMaps\"; } 
		}

		public static string MyLocaleFolder
		{
			get { return MyCustomAssetsFolder + @"Localization\"; }
		}
	}
}
