using System.Configuration;
using System.Diagnostics;
using System.Windows.Forms;

namespace Railroads.ScenarioManager.Core
{
	public static class ManagerApplication
	{
		private static object				ms_oSyncLock = new object();
		private static Configuration		ms_oConfiguration;
		private static ApplicationSettings	ms_oAppSettings;



		public static Version ManagerVersion { get { return new Version(1, 3); } }


		public static Configuration Configuration
		{
			get
			{
				if (ms_oConfiguration == null)
				{
					lock (ms_oSyncLock)
					{
						if (ms_oConfiguration == null)
						{
							//_configuration = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
							string s = Application.ExecutablePath;
							ms_oConfiguration = ConfigurationManager.OpenExeConfiguration(s);
						}
					}
				}

				return ms_oConfiguration;
			}
		}


		public static ApplicationSettings AppSettings
		{
			get
			{
				if (ms_oAppSettings == null)
				{
					lock (ms_oSyncLock)
					{
						if (ms_oAppSettings == null)
						{
							ms_oAppSettings = Configuration.GetSection("managerSettings") as ApplicationSettings;
						}
					}
				}

				return ms_oAppSettings;
			}
		}
	}
}