using System.Collections.Generic;
using System.Diagnostics;
using System.Xml;

namespace Railroads.ScenarioManager.Core
{
	public class Model : XmlSetting
	{
		private string			m_sNifName;


		public Model()
		{
		}

		internal Model(string name)
		{
			m_sNifName = name;
		}

		public Model(ScenarioSettings rootSetting)
		{
			base.RootSetting = rootSetting;
		}


		protected Scenario Scenario { get { return (base.RootSetting as ScenarioSettings).Scenario; } }

		public string NifName { get { return m_sNifName; } set { Scenario.SetProperty(ref m_sNifName, value); } }


		public override void ToXml(XmlNode node)
		{
			XmlNode oModelNode = Utility.GetOrCreateChildElement(node, "Model[szNifName='" + m_sNifName + "']", "Model");

			Utility.SetChildElementValue(oModelNode, "szNifName", m_sNifName);
		}


		public override void FromXml(Scenario scenario, XmlNode node)
		{
			m_sNifName = Utility.GetChildElementValue<string>(node, "szNifName");
		}


		public override object Clone()
		{
			Model oClone = new Model();
			oClone.m_sNifName = m_sNifName;
			return oClone;
		}


		public override bool Validate(List<string> errors)
		{
			return true;
		}


		internal void SetRootSetting(XmlSetting root)
		{
			RootSetting = root;
		}

		public override string ToString()
		{
			return m_sNifName;
		}
	}
}
