using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.Xml;

namespace Railroads.ScenarioManager.Core
{
	public class ScenarioDepot : Depot
	{
		public static ScenarioDepot FromDepot(Depot depot)
		{
			ScenarioDepot oDepot = new ScenarioDepot();
			oDepot.Name = depot.Name;
			oDepot.IsAnnex = depot.IsAnnex;
			return oDepot;
		}


		public override void ToXml(XmlNode node)
		{
			XmlNode oDepotNode = Utility.GetOrCreateChildElement(node, "Depot[szName='" + base.Name + "']", "Depot");
			Utility.SetChildElementValue(oDepotNode, "szName", base.Name);
		}


		public override void FromXml(Scenario scenario, XmlNode node)
		{
			base.Name = Utility.GetChildElementValue<string>(node, "szName");

			Depot oDepot;
			if (Manager.Instance.BaseDepots.TryGetValue(base.Name, out oDepot))
			{
				base.IsAnnex = oDepot.IsAnnex;
			}
		}


		public override object Clone()
		{
			ScenarioDepot oClone = new ScenarioDepot();
			oClone.Name = base.Name;
			oClone.IsAnnex = base.IsAnnex;
			return oClone;
		}


		public override bool Validate(List<string> errors)
		{
			return true;
		}
	}
}
