using System;
using System.Xml;

namespace Railroads.ScenarioManager.Core
{
	public class ScenarioTrain : Train
	{
		public static ScenarioTrain AnyTrain = new ScenarioTrain(Scenario.ANY_TRAIN, "<Any Train>");


		public ScenarioTrain()
		{
		}


		public ScenarioTrain(string tag, string name)
		{
			Tag = tag;
			Name = name;
		}


		public override void ToXml(XmlNode node)
		{
			XmlNode oTrain = node.SelectSingleNode("Train[szName='" + Tag + "']");
			if (oTrain == null)
			{
				oTrain = Utility.CreateChildElement(node, "Train");
			}

			Utility.SetChildElementValue(oTrain, "szName", base.Tag);
		}


		public override void FromXml(Scenario scenario, XmlNode node)
		{
			base.Tag = Utility.GetChildElementValue<string>(node, "szName");

			Train oTrain;
			if (!Manager.Instance.BaseTrains.TryGetValue(base.Tag, out oTrain))
			{
				throw new ArgumentException("Could not find a train with the tag '" + base.Tag + "'.");
			}

			base.Name = oTrain.Name;
		}


		public override object Clone()
		{
			ScenarioTrain oClone = new ScenarioTrain();
			oClone.Tag = Tag;
			oClone.Name = Name;
			return oClone;
		}
	}
}