using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.Diagnostics;

namespace Railroads.ScenarioManager.Core
{
	public class ScenarioTrainTenderCar : TrainTenderCar
	{
		public static ScenarioTrainTenderCar FromTrainTenderCar(TrainTenderCar car)
		{
			ScenarioTrainTenderCar oTenderCar = new ScenarioTrainTenderCar();
			oTenderCar.Name = car.Name;
			return oTenderCar;
		}


		public override void ToXml(XmlNode node)
		{
			XmlNode oCarNode = Utility.GetOrCreateChildElement(node, "TenderCar[szName='" + base.Name + "']", "TenderCar");
			Utility.SetChildElementValue(oCarNode, "szName", base.Name);
		}


		public override void FromXml(Scenario scenario, XmlNode node)
		{
			base.Name = Utility.GetChildElementValue<string>(node, "szName");
		}


		public override object Clone()
		{
			ScenarioTrainTenderCar oResult = new ScenarioTrainTenderCar();
			oResult.Name = base.Name;
			//result.Tender = ScenarioTender.FromTender(base.Tender);
			return oResult;
		}


		public override bool Validate(List<string> errors)
		{
			return true;
		}
	}
}
