using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.Diagnostics;

namespace Railroads.ScenarioManager.Core
{
	public class ScenarioTrainGoodCar : TrainGoodCar
	{
		private string m_sGoodName;


		public string GoodName { get { return m_sGoodName; } set { m_sGoodName = value; } }


		public static ScenarioTrainGoodCar FromTrainGoodCar(TrainGoodCar car)
		{
			ScenarioTrainGoodCar oGoodCar = new ScenarioTrainGoodCar();
			oGoodCar.Name = car.Name;
			return oGoodCar;
		}


		public override void ToXml(XmlNode node)
		{
			XmlNode oCarNode = Utility.GetOrCreateChildElement(node, "TrainCar[szName='" + base.Name + "']", "TrainCar");
			Utility.SetChildElementValue(oCarNode, "szName", base.Name);
		}


		public override void FromXml(Scenario scenario, XmlNode node)
		{
			base.Name = Utility.GetChildElementValue<string>(node, "szName");

			//New for RR 1.1
			//Get the good name for TrainCars defined in the scenario TrainCars file
			m_sGoodName = Utility.GetChildElementValue<string>(node, "szGood", "", false);

			//TrainGoodCar baseCar;
			//if (!Manager.Instance.BaseTrainCars.TryGetValue(base.Name, out baseCar))
			//{
			//    throw new ArgumentException("Could not find good car named '" + base.Name + "'");
			//}

			//base.Good = ScenarioGood.FromGood(baseCar.Good);
		}


		public override object Clone()
		{
			ScenarioTrainGoodCar oResult = new ScenarioTrainGoodCar();
			oResult.Name = base.Name;
			//result.Good = ScenarioGood.FromGood(base.Good);
			return oResult;
		}


		public override bool Validate(List<string> errors)
		{
			return true;
		}
	}
}
