using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Xml;

namespace Railroads.ScenarioManager.Core
{
	public abstract class XmlSetting : ICloneable
	{
		private XmlSetting m_oRootSetting;

		public XmlSetting RootSetting
		{
			get { return m_oRootSetting; }
			set { m_oRootSetting = value; }
		}


		public abstract void ToXml(XmlNode node);

		public abstract void FromXml(Scenario scenario, XmlNode node);

		public abstract object Clone();

		public abstract bool Validate(List<string> errors);



		protected List<T> LoadSubSetting<T>(XmlNode node, string path) where T : XmlSetting, new()
		{
			T oSetting;
			List<T> oResults = new List<T>();
			XmlNodeList oNodeList = node.SelectNodes(path);
			if ((oNodeList != null) && (oNodeList.Count > 0))
			{
				foreach (XmlNode oSubNode in oNodeList)
				{
					oSetting = new T();
					oSetting.RootSetting = this.RootSetting;
					oSetting.FromXml(null, oSubNode);
					oResults.Add(oSetting);
				}
			}

			return oResults;
		}
	}
}